#include <carrot/Options.h>

static ItemInfo Options_info = {
  "options",
  "Global Options",
  "Carlos Christoffersen",
  DEFAULT_ADDRESS
};


// ***********************************************************************
// Double parameters. We need a way to correlate this with the
// information in dparams. IMPORTANT: To keep compiled modules working
// correctly always add new parameters at the end of existing ones. Do
// not insert parameters in the middle (unless you recompile
// everything).
// ***********************************************************************
static ParamHandler<double>::ParmInfo Options_dparams[] = {
  {"scale", "Default gain in internal gyrators (S)", false, 1e-3},
  {"temp", "Default temperature (degrees C)", false, 27.},
  {"tol", "Newton method tolerance", false, 1e-8},
  {"issf", "Initial source-stepping factor", false, .0001}
};

// Integer parameters
static ParamHandler<int>::ParmInfo Options_iparams[] = {
  {"printcir", "Print Circuit (1), also print models (2)", false, 0},
  {"maxiter", "Maximum number of Newton iterations", false, 10000},
  {"newton_verb", "Print Newton iterations", false, 0},
  {"int_terms", "Output internal node information (0: no)", false, 0}
};


ParmSet options("Global Options", &Options_info, 
		Options_dparams, OPT_MAX_DPARM_INDEX,
		Options_iparams, OPT_MAX_IPARM_INDEX);
