// This may look like C code, but it is really -*- C++ -*-
//
// Implements a regular capacitor
//
// 

#ifndef LType_H
#define LType_H 1

#include <carrot/FADBADLinearVCS.h>

class L_eval {
public:

  L_eval(int *iparm) {} // iparm not needed here

  // Main evaluation function. Only voltage dependence considered here.
  template <typename myDouble>
  inline void operator()(myDouble& c, myDouble* dparm)
  {
    const double &scale = options.getDHandler()->getParmVec()[OPT_SCALE];
    c = dparm[IND] * scale * scale;
  }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  //  int *iparm; // not necessary for this model

};

typedef FADBADLinearVCS<L_eval, LinearVCQS, MAX_DPARM_INDEX> LType;

#endif
