// This may look like C code, but it is really -*- C++ -*-
//
// Implements a regular resistor
//
// 

#ifndef RIType_H
#define RIType_H 1

class RI_eval {
public:

  RI_eval(int *iparm) {} // iparm not needed here

  // Main evaluation function. Only voltage dependence considered here.
  template <typename myDouble>
  inline void operator()(myDouble& r, myDouble* dparm)
  {
    const double &scale = options.getDHandler()->getParmVec()[OPT_SCALE];
    r = dparm[RINT] * scale * scale;
  }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  //  int *iparm; // not necessary for this model

};

typedef FADBADLinearVCS<RI_eval, LinearVCCS, MAX_DPARM_INDEX> RIType;

#endif
