// This may look like C code, but it is really -*- C++ -*-
//
// Implements the Isb current of a MOSFET in Level 3 Semi-empirical model
// (exactly the same as the GS current source)
//             
// 

#ifndef IsbL3_H
#define IsbL3_H 1

class IsbL3_eval {
public:
  // This are locally-defined variables
  enum {vt, MAX_TVAR_INDEX};
  enum {dummy, MAX_CVAR_INDEX};

  IsbL3_eval(int *iparm) {} // iparm not needed here

  
  
  // Main evaluation function. Only voltage dependence considered here.
  template <typename currDouble, typename voltDouble, typename paramDouble, 
	    typename varDouble, typename cvarDouble>
  inline void operator()(currDouble& isbL3, voltDouble* v, paramDouble* dparm, 
			 varDouble* tvar, cvarDouble* cvar)
  {
 // v[0] : Vbs
 
   paramDouble iss = dparm[IS]; 
   isbL3 = iss * (safe_exp(v[0]/tvar[vt])-1.);

   //getIdiode(ibs, v[0], tvar[VT], dparm);    
   //ibsL3 *= dparm[AREA];
    
    
  }

  // Adjust variables to a new temperature.
  template <typename tvarDouble, typename varDouble, typename tempDouble>
  inline void setTemp(tvarDouble* tvar, 
		      varDouble* dparm, varDouble* cvar, tempDouble& T)
  {
  tempDouble Tabs = T + tzero;
  tvar[vt] = kBoltzman * Tabs / eCharge;
  }
  
  // For efficiency, we may want to pre-calculate some expressions
  // that do not change with voltage or temperature.  Adjust variables
  // to a new parameter set.
  template <typename varDouble>
  inline void newParms(varDouble* cvar, varDouble* dparm)
  {
    // Do nothing.
  }

  // Calculate power. pout initially contains the current.
 // template <typename powerDouble, typename voltDouble, 
//	    typename paramDouble>
  //inline void power(powerDouble& pout, voltDouble* v, 
	//	    paramDouble* dparm)
  //{
   // pout *= v[0];
 // }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  //  int *iparm; // not necessary for this model

};

// No thermal port
typedef FADBADGenericVCS<IsbL3_eval, GenericVCCS, 1, 
			 MAX_DPARM_INDEX, TEMP, false> IsbL3;
// With thermal port
//typedef FADBADTGenericVCS<Ibs_eval, GenericVCCS, 2, 
			// MAX_DPARM_INDEX, TEMP> TIbs;
// Power source
//typedef FADBADPowerSource<Ibs_eval, 2, 
 			//  MAX_DPARM_INDEX, TEMP> IgdPS;


#endif
