// This may look like C code, but it is really -*- C++ -*-
//
// Implements a regular resistor
//
// 

#ifndef RType_H
#define RType_H 1

#include <carrot/FADBADLinearVCS.h>

class RI_eval {
public:

  RI_eval(int *iparm) {} // iparm not needed here

  // Main evaluation function. Only voltage dependence considered here.
  template <typename myDouble>
  inline void operator()(myDouble& g, myDouble* dparm)
  {
    myDouble r;
    
    // Calculate resistance. Assume all parameters are checked
    if (dparm[RSH] == 0.) 
      r = dparm[R];
    else
      r = dparm[RSH] * (dparm[L]-dparm[NARROW]) / (dparm[W]-dparm[NARROW]);
    
    myDouble dt = dparm[TEMP] - dparm[TNOM];
    r = r * (1. + (dparm[TC1] + dparm[TC2] * dt) * dt);
    // Set conductance
    g = 1. / r;
  }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  //  int *iparm; // not necessary for this model

};

typedef FADBADLinearVCS<RI_eval, LinearVCCS, MAX_DPARM_INDEX> RType;

#endif
