// This may look like C code, but it is really -*- C++ -*-
//
// Implements the per-section-length inductor in a TL
//
// 

#ifndef LType_H
#define LType_H 1

#include <carrot/FADBADLinearVCS.h>

class L_eval {
public:

  L_eval(int *iparm) 
  {
    this->iparm = iparm;
  }

  // Main evaluation function. Only voltage dependence considered here.
  template <typename myDouble>
  inline void operator()(myDouble& c, myDouble* dparm)
  {
    myDouble deltax = dparm[LENGTH] / double(iparm[NSECT]);
    myDouble l = sqrt(dparm[K]) * dparm[Z0MAG] / c0;
    const double &scale = options.getDHandler()->getParmVec()[OPT_SCALE];
    c = l * scale * scale * deltax;
  }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  int *iparm; 

};

typedef FADBADLinearVCS<L_eval, LinearVCQS, MAX_DPARM_INDEX> LType;

#endif
