// This may look like C code, but it is really -*- C++ -*-
//
// Implements the per-section-length resistor in a TL
//
// 

#ifndef RType_H
#define RType_H 1

class R_eval {
public:

  R_eval(int *iparm) 
  {
    this->iparm = iparm;
  } 

  // Main evaluation function. 
  template <typename myDouble>
  inline void operator()(myDouble& r, myDouble* dparm)
  {
    myDouble deltax = dparm[LENGTH] / double(iparm[NSECT]);
    myDouble alpha_nepers = dparm[ALPHA] * 0.11512925;
    if (dparm[FSCALE] != 0. && dparm[FOPT] != 0.) 
      alpha_nepers *= sqrt(dparm[FOPT] / dparm[FSCALE]); 
    const double &scale = options.getDHandler()->getParmVec()[OPT_SCALE];
    r = 2 * alpha_nepers * dparm[Z0MAG] * deltax * scale * scale;
  }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  int *iparm; 

};

typedef FADBADLinearVCS<R_eval, LinearVCCS, MAX_DPARM_INDEX> RType;

#endif
