// This may look like C code, but it is really -*- C++ -*-
//
// GenericVCQS is the same as GenericVCCS but intended for charges.
//
//          2      
//          o                        o   o   o         o      
//          |                                                
//          |      	             +   +   +         +     
//         (^) q(v1,v2,v3,...,vn)    v1  v2  v3        vn
//          |      	             -   -   -         -     
//          |                                              
//          o      	             o   o   o         o     
//          1      
//
// a GenericVCQS have at least 2 terminals (1 and 2).
// 
// by Carlos E. Christoffersen

#ifndef GenericVCQS_H
#define GenericVCQS_H 1

#include <carrot/GenericVCCS.h>

class GenericVCQS : public GenericVCCS
{
public:

  // ncvolt is the number of controlling voltages. Number of terminals
  // is: 2 output terminals + 2*number of controlling terminals.  
  GenericVCQS(const int& ncvolt) : GenericVCCS(ncvolt) {}
  
  virtual ~GenericVCQS() {}

};

typedef std::vector<GenericVCQS*> GenVCQSVector;

#endif
