// This may look like C code, but it is really -*- C++ -*-
//
// 
// This is a base class for all CS/QS that can be used by a MacroElement
//
// by Carlos E. Christoffersen

#ifndef InternalCS_h
#define InternalCS_h 1

class InternalCS
{
public:

  InternalCS() : termNumVec(0) {} 

  virtual ~InternalCS() {}

  // Initialization: used for taping, error checking, etc.
  // Defaults to nothing.
  // This should be called after any changes in parameters.
  virtual void init() {}

  inline const int* getTermNumVec() const
  {
    assert(termNumVec);
    return termNumVec;
  }

  // Set internal terminal number vector.  WARNING: there is no check
  // on the size of the val_vec array. Also, NO MEMORY IS ALLOCATED
  // HERE.
  inline void setTermNum(const int* val_vec)
  {
    termNumVec = val_vec;
  }
   
private:
  
  const int *termNumVec;

};

#endif


