// This may look like C code, but it is really -*- C++ -*-
//
// LinearVCQS is the same as LinearVCCS but for charges
//
//          1                        3
//          o                        o       
//          |                               
//          |                        +      
//         (^) g v1                  v1  
//          |                        -      
//          |                             
//          o                        o      
//          2                        4
//
// This is all we need for linear elements. If there are more than one
// controlling voltage we just add 2 or more LinearVCQS in parallel.
//
// by Carlos E. Christoffersen

#ifndef LinearVCQS_h
#define LinearVCQS_h 1

#include <carrot/LinearVCCS.h>

class LinearVCQS : public LinearVCCS
{
public:

  LinearVCQS(const double& gain) : LinearVCCS(gain) {}

  virtual ~LinearVCQS() {}

};

typedef std::vector<LinearVCQS*> LinVCQSVector;

#endif


