// This may look like C code, but it is really -*- C++ -*-
//
// Get the DC operating point of a circuit
// 
// by Carlos E. Christoffersen

#ifndef OP_H
#define OP_H

#include <carrot/Circuit.h>
#include <carrot/UMFPackDI.h>

class Circuit;

class OP 
{
public:

  OP(Circuit *cir);

  ~OP();

  // Find single DC operating point. Returns residual.
  double op(const int& nrcs, UMFPackDI& nam, 
	    double* uvec, double *svec,
	    int& iter, int& rejections, double* q=0);

  int fillNAMandRHS(UMFPackDI& nam, double* svec, double* uvec_j, 
		    const double& beta, const double& gmin);

private:
  
  // Workspace variables
  GenVCCSVector genvccs;
  LinVCCSVector linvccs;
  IndepCSVector indvccs;
  GenVCQSVector genvcqs;
  double *dij;
  double *vj;
};

#endif
