/*  Copyright Garrett Kajmowicz, 2004.  Licenced under the GNU GPL.
 *  This file defines a set of functions which will load the modules for 
 *  object definitions and code.
 *
 *
 */


#ifndef ObjectLoader_H
#define ObjectLoader_H


#include <string>
#include <map>

#include <carrot/ModuleFunctions.h>
#include <carrot/nocase_cmp.h>

typedef std::map<std::string, ModuleFunctions, nocase_cmp > ModuleMap;



//The following function takes a path location and returns all
//of the information required to use the modules

//std::map<std::string, ModuleFunctions> openModules(const std::string path = "." , 
//	std::map<std::string, ModuleFunctions> retval = std::map<std::string, ModuleFunctions>() );
ModuleMap openModules(const std::string path = ".", bool printflag = false,
		      ModuleMap retval = ModuleMap() );
//void closeModules(std::map<std::string, ModuleFunctions> & m);
void closeModules(ModuleMap & m);


#endif
